---

- hosts: k8s_nodes
  tasks:
    
    - name: Add rhel-7-server-extras-rpms
      rhsm_repository:
        name: rhel-7-server-extras-rpms
        state: enabled
      become: true
    # https://kubernetes.io/docs/setup/production-environment/container-runtimes/

    - name: Add Docker repo
      get_url:
        url: https://download.docker.com/linux/centos/docker-ce.repo
        dest: /etc/yum.repos.d/docker-ce.repo
      become: true

    - name: modify the Docker Repo Info as of 10/31/2020 the info in this file is broken so it need to be changed
      raw: sudo sed -i 's/$releasever/7/g' /etc/yum.repos.d/docker-ce.repo 
    
    - name: Install Docker and Dependencies
      raw: sudo yum install -y lvm2 container-selinux docker-ce docker-ce-cli containerd.io 
 
 #   - name: Install Docker and Dependencies
 #     yum:
 #       name: 
 #         - lvm2
 #         - docker
 #         - container-selinux
 #         - docker-ce
 #       state: present
 #     become: true


    - name: Create a directory if it does not exist
      file:
        path: /etc/docker
        state: directory
        mode: '777'
      become: true

    - name: Create a directory if it does not exist
      file:
        path: /etc/systemd/system/docker.service.d
        state: directory
        mode: '777'
      become: true

    - name: Set up docker service config file
      shell:
        cmd: |
          cat > /etc/docker/daemon.json <<EOF
          {
          "exec-opts": ["native.cgroupdriver=systemd"],
          "log-driver": "json-file",
          "log-opts": {
          "max-size": "100m"
          },
          "storage-driver": "overlay2",
          "storage-opts": [
          "overlay2.override_kernel_check=true"
          ]
          }
          EOF
      become: true

    - name: Start Docker service
      service:
        name: docker
        state: started
        enabled: yes
      become: true
        
    - name: Turn off the Firewall
      systemd:
         name: firewalld
         state: stopped
         enabled: false
      become: true

    - name: Remove swapfile from /etc/fstab
      mount:
              name: "{{ item }}"
              fstype: swap
              state: absent
      with_items:
       - swap
       - none
      become: true

    - name: Disable swap
      command: swapoff -a
      when: ansible_swaptotal_mb >0
      become: true
      
    - name: Add Kubernetes Repo
      yum_repository:
        name: Kubernetes
        description: Kuberenetes YUM repo
        file: kubernetes.repo
        baseurl: https://packages.cloud.google.com/yum/repos/kubernetes-el7-x86_64
        gpgcheck: no
        enabled: yes
        gpgkey:
         - https://packages.cloud.google.com/yum/doc/yum-key.gpg
         - http://packages.cloud.google.com/yum/doc/rpm-packages-key.gpg
      become: true

    - name: Install Kubernetes packages
      raw: sudo yum install -y kubelet kubeadm kubectl
      
#For some reason this would hang and never return so the above command takes its place         
#    - name: Install Kubernetes packages
#      become: true
#      yum:
#        name:
#          - kubelet
#          - kubeadm
#          - kubectl
#        state: present

    - name: Config KUBLET_EXTRA_ARGS
      shell:
        cmd: echo 'Environment="KUBELET_EXTRA_ARGS=--node-ip={{ hostvars[inventory_hostname]['ansible_default_ipv4']['address'] }}"' | sudo tee -a /usr/lib/systemd/system/kubelet.service.d/10-kubeadm.conf

    - name: Start Kubelet
      systemd:
         name: kubelet
         daemon_reload: yes
         enabled: true
      become: true

    - name: Add overlay Files system
      modprobe:
         name: overlay
         state: present
      become: true

    - name: Add br_netfilter
      modprobe:
         name: br_netfilter
         state: present
      become: true

    - name: Set up kubernetes IP tables in int conf file
      shell:
        cmd: |
          cat > /etc/sysctl.d/99-kubernetes-cri.conf <<EOF
          net.bridge.bridge-nf-call-iptables  = 1
          net.ipv4.ip_forward                 = 1
          net.bridge.bridge-nf-call-ip6tables = 1
          EOF
      args:
        executable: /bin/bash
      become: true

    - sysctl:
        name: net.ipv4.ip_forward
        value: '1'
        sysctl_set: yes
        state: present
        reload: yes      
      become: true

    - name: Copy Join Command shell file to node
      copy:
        src: /home/vagrant/join.sh
        dest: /home/vagrant/join.sh
  

    - name: Join node to cluster
      raw: sudo sh /home/vagrant/join.sh


